#ifndef __TASK_GPIO_H__
#define __TASK_GPIO_H__

#include "memory.h"
#include "xburst_types.h"

/* Special task versions of GPIO operations. */

#define TASK_GPIO_PXPIN(n)	(TASK_GPIO_BASE + (0x00 + (n)*0x100)) /* PIN Level Register */
#define TASK_GPIO_PXDAT(n)	(TASK_GPIO_BASE + (0x10 + (n)*0x100)) /* Port Data Register */
#define TASK_GPIO_PXDATS(n)	(TASK_GPIO_BASE + (0x14 + (n)*0x100)) /* Port Data Set Register */
#define TASK_GPIO_PXDATC(n)	(TASK_GPIO_BASE + (0x18 + (n)*0x100)) /* Port Data Clear Register */

#define TASK_REG_GPIO_PXPIN(n)	REG32(TASK_GPIO_PXPIN((n)))  /* PIN level */
#define TASK_REG_GPIO_PXDAT(n)	REG32(TASK_GPIO_PXDAT((n)))  /* 1: interrupt pending */
#define TASK_REG_GPIO_PXDATS(n)	REG32(TASK_GPIO_PXDATS((n)))
#define TASK_REG_GPIO_PXDATC(n)	REG32(TASK_GPIO_PXDATC((n)))

void task_gpio_init(unsigned short task);
void task_gpio_set_pin(unsigned short pin);
void task_gpio_clear_pin(unsigned short pin);
int task_gpio_get_pin(unsigned short pin);

#endif /* __TASK_GPIO_H__ */
